//+------------------------------------------------------------------+
//|                                              15SecChartMaker.mq4 |
//|                                         Copyright (c) 2010, fai. |
//|                                    http://d.hatena.ne.jp/fai_fx/ |
//+------------------------------------------------------------------+
//
// 1. Attach the EURUSD 5M chart.
// 2. Open the  EURUSD_15S Offline-chart.
//    You can use 15sec-chart!  :-)


#property copyright "Copyright (c) 2010, fai."
#property link      "http://d.hatena.ne.jp/fai_fx/"

#property indicator_chart_window

#include <WinUser32.mqh>
#define  CHART_CMD_UPDATE_DATA            33324
#define  HEADER_BYTE                        129
#define  DATA_BYTE                           44

extern int     IntervalSec = 15;// second
extern int     OmitDigit = 0;// 1=> 1.00000 -> 1.0000


int      FileHandle = -1;
string   MySymbol ="";

int init()
  {
   MySymbol = Symbol() + "_"+IntervalSec+"S";
   WriteHistoryHeader();
   return(0);
  }
  
int start()
  {
   static datetime lasttime = 0;
   static double open_t=0,close_t=0,high_t=0,low_t=0;
   static int volume_t = 1;
   if(open_t==0){ open_t=Bid;close_t=Bid;high_t=Bid;low_t=Bid;}
   
   datetime tm = MathFloor(TimeCurrent()/IntervalSec)*IntervalSec;
   if(lasttime !=tm){
      WriteHistoryData(tm-IntervalSec,open_t,close_t,high_t,low_t,volume_t,true);
      lasttime =tm;
      open_t=Bid;close_t=Bid;high_t=Bid;low_t=Bid;volume_t = 1;
   }
   if(Bid > high_t) high_t = Bid;
   if(Bid < low_t) low_t = Bid;
   close_t = Bid;
   volume_t++;
   WriteHistoryData(tm,open_t,close_t,high_t,low_t,volume_t,false);

   //Comment(TimeToStr(TimeCurrent(),TIME_SECONDS)+"  "+TimeToStr(tm,TIME_SECONDS));
   
   UpdateChartWindow();
   return(0);
  }
//+------------------------------------------------------------------+

int WriteHistoryHeader()
{
   string c_copyright;
   int    i_digits = Digits-OmitDigit;
   int    i_unused[13] = {0};
   int    version = 400;   
   FileHandle = FileOpenHistory(MySymbol + "1.hst", FILE_BIN|FILE_WRITE|FILE_READ);
   if (FileHandle < 0) return (-1);
   c_copyright = "(C)opyright 2003, MetaQuotes Software Corp.";
   FileWriteInteger(FileHandle, version, LONG_VALUE);
   FileWriteString(FileHandle, c_copyright, 64);
   FileWriteString(FileHandle, MySymbol, 12);
   FileWriteInteger(FileHandle, 1, LONG_VALUE);
   FileWriteInteger(FileHandle, i_digits, LONG_VALUE);
   FileWriteInteger(FileHandle, 0, LONG_VALUE);       //timesign
   FileWriteInteger(FileHandle, 0, LONG_VALUE);       //last_sync
   FileWriteArray(FileHandle, i_unused, 0, ArraySize(i_unused));
   FileClose(FileHandle);
   return (0);
}
//+------------------------------------------------------------------+
void WriteHistoryData(datetime tm,double open_t,double close_t,double high_t,double low_t,int volume_t,bool newBar)
{

   FileHandle = FileOpenHistory(MySymbol + "1.hst", FILE_BIN|FILE_WRITE|FILE_READ);
   if (FileHandle >= 0) {
      if(newBar){
         FileSeek(FileHandle,FileSize(FileHandle), SEEK_CUR);
      }else{
         FileSeek(FileHandle,FileSize(FileHandle)-DATA_BYTE*1, SEEK_CUR);
      }
      FileWriteInteger(FileHandle, tm, LONG_VALUE);
      FileWriteDouble(FileHandle, open_t, DOUBLE_VALUE);
      FileWriteDouble(FileHandle, low_t, DOUBLE_VALUE);
      FileWriteDouble(FileHandle, high_t, DOUBLE_VALUE);
      FileWriteDouble(FileHandle, close_t, DOUBLE_VALUE);
      FileWriteDouble(FileHandle, volume_t, DOUBLE_VALUE);
      FileFlush(FileHandle);
      FileClose(FileHandle);
   }
}
//+------------------------------------------------------------------+
int UpdateChartWindow()
{
   static int hwnd = 0;

   if (FileHandle < 0) {
      //no HST file opened, no need updating.
      return (-1);
   }
   if(hwnd == 0) {
      //trying to detect the chart window for updating
      hwnd = WindowHandle(MySymbol, 1);
   }
   if(hwnd!= 0) {
      if (IsDllsAllowed() == false) {
         //DLL calls must be allowed
         Alert("ERROR: [Allow DLL imports] NOT Checked.");
         return (-1);
      }
      if (PostMessageA(hwnd,WM_COMMAND,CHART_CMD_UPDATE_DATA,0) == 0) {
         //PostMessage failed, chart window closed
         hwnd = 0;
      } else {
         //PostMessage succeed
         return (0);
      }
   }
   //window not found or PostMessage failed
   return (-1);
}
//+------------------------------------------------------------------+

